/****************************************************************
int_level.c            (przerwania wyzwalane poziomem lub zboczem)


Program ilustruje sposb uycia przerwania zewntrznego 
wyzwalanego poziomem.
Program gwny generuje na linii P3_5 (Buzzer) sygna 
dwikowy. Nacinicie przycisku P3.2 (INT0) powoduje przerwanie
a to sprawia, e grupa diod LEDS wywietla kolejne stany
licznika piercieniowego (jedna dioda jest zapalona, pozostae
s zgaszone).

*****************************************************************/

#include "51xD2.h"         // zbir definiujcy rejestry procesora 

sbit    Buzzer = P3^5;               // definicja przycisku Button 
#define  LEDS      P2                           // zesp diod LED 

void Delay (WORD) reentrant;           // prototyp funkcji "Delay"
           // reentrant oznacza e moe by wywoywana w programie
                        // main  i w podprogramie obsugi przerwa 
//----------------------------------------------------------------
void main(void) {
   EX0=1;                       // odblokowanie przerwania od INT0
   IT0=0;           // przerwanie INT0 wywoane poziomem 0 na INT0
   // IT0=1;           // przerwanie INT0 wywoane zboczem na INT0
   EA =1;                      // odblokowanie wszystkich przerwa 
   while(1) {
      Buzzer=!Buzzer;    
      Delay(0x7ff);                      // krtki czas opnienia
   } 
}

// podprogram opnienia -----------------------------------------
void Delay (WORD wait ) reentrant {       
  WORD i;

  for(i=0;i<wait;i++){};
}

// podprogram obsugi przerwania INT0 ----------------------------
void EX0_int(void) interrupt 0 using 1 { 

  static BYTE i=1;         // definicja "static" zapewnia, e stan 
                                     //zmiennej  "i" nie zginie po 
                                          // wyjciu z podprogramu 
 
  i= (i==0x80 ) ? 1 : i<<1; // realizacja licznika piercieniowego 
                        
  LEDS=~i;           // negacja powoduje e wieci jedna dioda LED  
  Delay(0x1FFF);//podprogram wyzwalany poziomem dziaa zbyt szybko  
             //dla przerwa wyzwalanych zboczem Delay mona usun  
}

