/*****************************************************************
int_priority.c                        (2 przerwania z priorytetami)

Program gwny (main) generuje ton na bicie P3_5 "Buzzer".
Naciniecie przycisku P3_3 (INT1) powoduje przerwanie i wywoanie 
podprogramu jego obsugi. Podprogram obsugi tego przerwania uaktywnia
dziaanie licznika binarnego, ktrego stany prezentowane s przez grup
diod LEDS.       

Naciniecie przycisku P3_2 (INT0) powoduje przerwanie i wywoanie 
podprogramu jego obsugi. Podprogram obsugi tego przerwania zmienia
stan licznika binarnego widoczny na diodach LEDSx (dopki 
nie zostanie zakoczony program obsugi przerwania stan licznika 
nie zmieni si).

Dla zrozumienia co to znaczy, e przerwanie ma wyszy priorytet
naley skompilowa program dwa razy ustawiajc:
 IPL0 =0x00;  - przerwanie  INT0 ma wyszy priorytet ni INT1  
 IPL0 =0x04;  - przerwanie  INT1 ma wyszy priorytet ni INT0 

*****************************************************************/

#include "51xD2.h"         // zbir definiujcy rejestry procesora 

sbit    Buzzer = P3^5;               // definicja przycisku Button 
#define  LEDS      P2                           // zesp diod LED 
#define  LEDSx     P1                     // dodatkowy zesp diod

void Delay (WORD) reentrant;           // prototyp funkcji "Delay"
           // reentrant oznacza e moe by wywoywany w programie
                        // main  i w podprogramie obsugi przerwa 
//----------------------------------------------------------------
void main(void) {
  EX0=1; EX1=1;     
  IT0=0; IT1=0;                   // przerwania wyzwalane poziomem 
  IPL0 =0x00;          //  zmie warto na 0x04 ! Porwnaj wyniki 

   EA =1;                      // odblokowanie wszystkich przerwa 
   while(1) {
      Buzzer=!Buzzer;    
      Delay(0x7FF);                      // krtki czas opnienia
   } 
}

// podprogram opnienia -----------------------------------------
void Delay (WORD wait ) reentrant {       
  WORD i;
  for(i=0;i<wait;i++){};
}

// podprogram obsugi przerwania INT0 ----------------------------
void EX0_int(void) interrupt 0 using 1 { 
  static BYTE i=1;         // definicja "static" zapewnia, e stan 
                                     //zmiennej  "i" nie zginie po 
                                          // wyjciu z podprogramu 
 
  i++;                            // realizacja licznika binarnego 
  LEDSx=~i;                // negacja powoduje e dioda LED wieci
  while(!INT0){};           // dopki przycisk INT0 jest wcinity
                                 // pozostajemy w tym podprogramie
                       
}

// podprogram obsugi przerwania INT1 ----------------------------
void EX1_int(void) interrupt 2 using 2 { 

  static BYTE i=1;         // definicja "static" zapewnia, e stan 
                                     //zmiennej  "i" nie zginie po 
                                          // wyjciu z podprogramu 
 
  i--;                            // realizacja licznika binarnego 
  LEDS=~i;                 // negacja powoduje e dioda LED wieci
  Delay(0x1FFF);//podprogram wyzwalany poziomem dziaa zbyt szybko 
}

