/*****************************************************************
led_1sec.c  (Timer0 powoduje mruganie diody LED dokadnie co 1sek)

Program powoduje mruganie diody LED w ten sposb, 
e dioda LED wieci przez 1 sek i jest zgaszona przez 1 sekund. 
rdem przerwa jest ukad Timer0. Powoduje on przerwanie co 
0.005 sek. Aby odliczy czas 1 sek podprogram musi by wywoany 
200 razy. Podprogram ten take generuje krtkie dwiki 
wydawane przez Buzzer z wbudowanym generatorem. 
*****************************************************************/

#include "51xD2.h"         // zbir definiujcy rejestry procesora 
#define  Buzzer     P3_5           // definicja adresu bitu Buzzer 
#define  LED        P1_0                  // dodatkowy zesp diod  

#define TH0RELOAD    0xd8        // 0xd8f0 = -10000 dla Fosc=24MHz
#define TL0RELOAD    0xf0        // ...    
#define SECOND       200         //1sek to 200  przerwa od Timer0

//----------------------------------------------------------------
void main(void) {  
    TH0  = TH0RELOAD;                  
    TL0  = TL0RELOAD;
    TMOD = TMOD | 0x01;                  // tryb dla Timer0: mode1
    TR0  = 1;                                      // start Timer0
    ET0  = 1;                     // zgoda na przerwania od Timer0  
    EA   = 1;                          // zezwolenie na przerwania     

    while(1) {};                    // program gwny nie robi nic
}

//podprogram przerwania ------------------------------------------
void T0_int(void)  interrupt 1 using 1 {   

  static BYTE count=0; 
  TH0 = TH0RELOAD;                       // reload Timer0 registers     
  TL0 = TL0RELOAD;
  Buzzer=1;                     // Buzer sygna o dugoci 1/200sek

  if (++count == SECOND)  {    // odliczanie liczby przerwa do 200  
      Buzzer=0;                                 // uaktywnij Buzzer
      count = 0;       // zeruj licznik odliczajcy czas jednej sek
      LED=!LED;                               // mruganie diody LED
     }
}

