/*****************************************************************
f_measure.c           (zliczanie impulsw - pomiar czstotliwoci)

Program zlicza impulsy w czasie 1 sekundy. Liczba impulsw w 
jednej sekundzie to czstotliwo. Do zliczania impulsw suy 
ukad Counter0. Mierzone impulsy podawane s na lini P3_4.
Ukad Counter0 uaktywniany Lini INT0 (P3_2). Czas otwarcia ukadu
zliczania jest odmierzany ukadem Timer1.
Zakres pomiarw 10Hz do 65535Hz.
*****************************************************************/

#include "51xD2.h"         // zbir definiujcy rejestry procesora
#include <stdio.h>
#define  LEDS_high      P2                          // zesp diod
#define  LEDS_low       P0                // dodatkowy zesp diod
#define  LED            P1_0                    // dodatkowa dioda

#define TH1RELOAD    0xd8        // 0xd8f0 = -10000 dla Fosc=24MHz
#define TL1RELOAD    0xf0        // ...    
#define SECOND       200         //1sek to 200  przerwa od Timer0

//----------------------------------------------------------------
void main(void) {  
 TMOD=0x0D;                              // GATE=1, Counter MODE=1
 TR0=1;
 TH1  = TH1RELOAD;                  
 TL1  = TL1RELOAD;
 TMOD = TMOD | 0x10;                     // tryb dla Timer0: mode1
 TR1  = 1;                                         // start Timer0
 ET1  = 1;                        // zgoda na przerwania od Timer0
 EA   = 1;                             // zezwolenie na przerwania
 while(1) {
    while(!INT0) {};  
    while(INT0)  {};              // linia INT0 bramkuje zliczanie

    LEDS_low = ~TL0;    // wywietl liczb impulsw na diodach LED
    LEDS_high= ~TH0;                           // ...    (16bitw)
    TH0=0; TL0=0;        // zeruj liczniki TH0, TL0 przed pomiarem
 } 
}

//podprogram przerwania ------------------------------------------
void T1_int(void) interrupt 3 using 1 {   

  static BYTE count=0; 
  TH1 = TH1RELOAD;                // czas do nastpnego przerwania
  TL1 = TL1RELOAD;
  if (++count == SECOND)  {   // odliczanie liczby przerwa do 200
      count = 0;      // zeruj licznik odliczajcy czas jednej sek.
      INT0=LED=!LED; //mruganie diody LED i bramkowanie odliczania
    }
}

