/*****************************************************************
shift_soft.c                   (transmisja do rejestru przesuwnego)

Program wysya programowo (software'owo) znak (8-bitw) do 
rejestru przesuwnego 74LS164. 
W wyniku dziaania programu diody LED podczone do rejestru
przesuwnego dziaaj jak licznik binarny w takt naciskania P3_2.
Podprogram _getkey() nie jest wykorzystywany - moe by uyty do
odczytu informacji z rejestru przesuwnego np. 74HC165.
******************************************************************/
#include "51xD2.h"         // zbir definiujcy rejestry procesora 

void putc(char );              // prototyp funkcji nadawania znaku
char _getkey(void);              // prototyp funkcji odbioru znaku 

//----------------------------------------------------------------
void main(void) {  
 BYTE i; 
 while(1) {
     while (P3_2);            // czekanie na nacinicie przycisku
     while (!P3_2);
     putc(i++);         //  nadawanie kolejnych wartoci binarnych
 }                        
}

#include <intrins.h>
// definicja linii do rejestru przesuwnego  (dowolne piny portw!) 
#define    clk          P3_1                        // linia clock 
#define    TxRx_pin     P3_0      // linia nadawania/odbioru bitw 

//--------------------------    nadawanie znaku poprzez zcze SIO 
void putc(BYTE d) {
  BYTE i;
  TxRx_pin=1;
  for(i=0;i<8;i++) {                      // wysanie bitw danych 
    TxRx_pin=(bit)(d & 0x01);   // wystawienie danej do transmisji 
    d >>= 1;                               // przesunicie w prawo 
    clk=1;
    clk=0;                           // generowanie impulsu zegara 
    clk=1;
  }
  TxRx_pin=1;
}

//--------------------------   odbir znaku z rejestru przesuwnego
char getc(void)  {                
  BYTE i,d=0;
  TxRx_pin=1;
  for(i=0;i<8;i++) {  
    d |= (BYTE)TxRx_pin;                           // odczyt danej 
    d  =_cror_(d,1);                             // rotacja danych 
    clk=1;                                   
    clk=0;                           // generowanie impulsu zegara 
    clk=1; 
  }   
  return (d);                     
}

