/*****************************************************************
SIO_soft.c    (transmisji szeregowa  zorganizowana programowo 
                                                  ...software'owo) 

Program demonstruje moliwo organizacji transmisji szeregowej 
programowo, bez uywania wewntrznego ukadu USART.

Na terminalu transmisji szeregowej pojawia si napis "Jak Sie masz
Nacisnij cos...". Program czeka na nacinicie dowolnego
klawisza na klawiaturze komputera. Nacinity znak pojawia si na 
terminalu.
Program transmituje i odbiera znaki z parametrami:
               szybko 9600 bps, 
               8-N-1 (8-bitw, N- bez parzystoci, 1 bit stopu).
Wyniki dziaania s widoczne na terminalu transmisji szeregowej.
Wywoaj program typu HYPERTERMINAL (lub lepszy).

****************************************************************/
#include "51xD2.h"     // zbir definiujcy rejestry procesora
#include <stdio.h> 
#include <intrins.h>

#include <stdio.h> 

void putc(WORD);              // prototyp funkcji nadawania znaku 
char _getkey(void);         // prototyp funkcji odbioru znaku nie 
              //... jest konieczny bo jest zdefiniowany w stdio.h 

//----------------------------------------------------------------
void main(void) {  
 code char t[]="\r Jak Sie masz !\r";  
 BYTE i,c;

  while(1) {
    for (i=0;t[i];i++) putchar(t[i]);      // napis "Jak Sie masz"
    puts(" Nacisnij cos...\n ");                                  
    c=getkey();                                // czekanie na znak
    putchar(c);           // odebrany znak pojawi si na terminalu
    printf("\n Odebrany znak : %c (HEX:%02bx DEC:%03bu)" ,c,c,c);
 }                       
}

// definicja linii transmisji szeregowej   (dowolne piny portw !)
#define    txd_pin     P3_1                           // linia TxD
#define    rxd_pin     P3_0                           // linia RxD

/*----------------------------------------------------------------
 obliczenie czasu trwania jednego bitu transmisji:                
 n=Int(Fosc/(36*BAUD)-14)+2  gdzie BAUD jest szybkoci bodowa, 
 a Fosc czstotliwoci oscylatora mikroprocesora   
-----------------------------------------------------------------*/

#define _speed_4800   127        // szybko transmisji  4800 bodw
#define _speed_9600    57        // szybko transmisji  9600 bodw
#define _speed_19200   23      // szybko transmisji   19200 bodw

#define _baud    _speed_9600         // bieca szybko transmisji

#pragma  OT(6,Speed)

//-----------------------------------------------------------------
void putc(WORD d) {
  BYTE i,time;
  txd_pin=1;              // na wszelki wypadek linia transmisji =1 
  d |=0xFF00;                      // dodanie bitu start do danej d 
  d <<= 1;                          // dodanie bitu stop do danej d 

  for(i=0;i<10;i++) {          // wysanie bitw: start, dane, stop 
    txd_pin=(bit)(d & 0x01);     // wystawienie danej do transmisji 
    d >>= 1;                                // przesunicie w prawo 
    for(time=0;time<(_baud+7);time++){};    // czas bitu transmisji 
  }
}

//-----------------------------------------------------------------
char _getkey(void)  {            // odbir znaku poprzez zcze SIO 
  BYTE i,time;
  WORD d=0;

  while(rxd_pin==1);                      // czekanie na bit startu 
  for(time=0;time<(_baud>>1);time++){};        // odczekaj 1/2 bitu
  for(i=0;i<9;i++) {                              // odczyt 9 bitw 
    d |= (WORD)(rxd_pin);            
    d  =_iror_(d,1);                              // rotacja danych 
    for(time=0;time<_baud;time++){};        // czas bitu transmisji 
  }

  return  d>>8 ;                     
}

//-----------------------------------------------------------------
char putchar(char c) {        // nadawanie znaku poprzez zcze SIO 
  putc( c);                                           
  return c;
}

