/******************************************************************
IDLE_s.c                                     (prosty program IDLE)

Program demonstruje uycie energooszczdnego trybu IDLE 
mikrokontrolera. Do wyprowadzenia procesora ze stanu IDLE mona 
uy dowolnego przerwania, w tym przypadku przerwania INT0 (P3.2).
Procedura przerwania jest pusta bo suy tyko do powrotu ze 
stanu IDLE. W stanie IDLE wiec 4 bardziej znaczce diody 
portu LEDS.
******************************************************************/
#include "51xD2.h"          // zbir definiujcy rejestry procesora 
#define  LEDS       P1                               // zesp diod  

//-----------------------------------------------------------------
void main(void) { 
  unsigned long i;
  EX0=1;     
  IT0=1;                           // przerwanie wyzwalane poziomem    
  EA =1; 
  while(1) {
     LEDS=0x0f;            // 4 bardziej znaczce diody LEDS wiec 
     PCON |=0x01;             // wprowadzenie procesora w stan IDLE 
                       // kade przerwanie usuwa stan IDLE, np.INT0  
                // tu zatrzymuje si program czekajc na przerwanie
     LEDS=0xf0;               // 4 mniej znaczce diody LEDS wiec 
     for (i=0;i<0xffff;i++){};                   // czas opnienia
  }
}

//-------------------------------------- przerwanie zewntrzne INT0
void INT0_int (void) interrupt 0  {   
              // pusta procedura obsugi przerwania usuwa stan IDLE 
} 
