/*****************************************************************
pwm_LED.c    (ukad PWM i Timer0 powoduj wytwarzanie modulowanego
        ...dwiku lub cige zmiany jasnoci wiecenia diody LED)

Program generuje dwik o zmiennej wysokoci w czasie trwania.
Program gwny (main) po inicjalizacji PWM dla moduu 4 
(P1_7) wykonuje ptl bez koca czekajc na przerwania.
Ukad Timer0 co zadany stay okres czasu powoduje przerwanie. 
Podprogram obsugi przerwania aduje now 
warto do rejestru CCAP4H co zmienia szeroko impulsu PWM
i co za tym idzie zmienia ton generowany przez Buzzer lub zmienia
jasno wiecenia diody LED.
*****************************************************************/

#include "51xD2.h"         // zbir definiujcy rejestry procesora
#define Buzzer  P1_7
void PWM_init (void);         // przygotowanie ukadu PWM do pracy

//----------------------------------------------------------------
void main(void) {
                         
     TMOD=0x01;                      // tryb 1 - dla ukadu Timer0
     TL0=TH0 =0x00;        // pocztkowa warto dla ukadu Timer0
     TR0 =1;                                // start ukadu Timer0
     ET0 = 1;         // zezwolenie na przerwania od ukadu Timer0
     EA =1;                               // odblokowanie przerwa
     PWM_init();                   //przygotownie PWM do dziaania
     while(1) {}                    // ptal bez koa: nic nie rb
}

// przygotowanie PWM do dziaania -------------------------------- 
void PWM_init (void) {
  P1_7 = 1;                  // przygotowanie wyjcia PWM: modu 4
  CMOD = 0x00;                        // PCA clock = Fosc/12 =2MHz
  CCAPM4 = 0x42;              // ustaw tryb pracy  CCAPM0 jako PWM
  CCAP4H = 0x00;         // ustaw pocztkow szeroko impulsu PWM
  CR = 1;                                       // start PCA timer
}

// przerwanie Timer0 ---------------------------------------------
void T0_int (void) interrupt 1 using 2 {  
     CCAP4H--;                     //  zmie szeroko impulsu PWM
     TH0=0xe8;                // czas opnienia dla ukadu Timer0
}

