/*******************************************************************
WDT.c                  (Przykad jak doda WATCHDOG WDT do programu)

Jest to modyfikacja programu sio.c po to aby pokaza jak uy 
ukadu WATCHDOG.
Po wczeniu program 3 razy zapala i gasi diody LED portu P1.
Na terminalu transmisji szeregowej pojawia si napis "Jak si masz !
Nacisnij cos...". Program czeka na nacinicie dowolnego
klawisza na klawiaturze komputera. Nacinity znak pojawia si na 
terminalu.
Program transmituje i odbiera znaki z parametrami:
               szybko 9600 bps, 
               8-N-1 (8-bitw, N- bez parzystoci, 1 bit stopu).
Wyniki dziaania s widoczne na terminalu transmisji szeregowej.
Wywoaj program typu HYPERTERMINAL (lub lepszy).
*******************************************************************/
#include "51xD2.h"           // zbir definiujcy rejestry procesora 
#include <stdio.h> 
#include "SIO_init.h"

#define WDTkick     WDTRST= 0x1e;  WDTRST= 0xe1;    // aktywacja WDT

//------------------------------------------------------------------
void main(void) {  
 code char t[]="\n Jak sie masz !\n";   
 WORD i,k;
 char c;
 for(k=0;k<6;k++) {
   for(i=0;i<0x5000;i++);              
   P1= ~P1;                   // Po RESET 3x zapal diody LED portu P1
 };
 
 WDTPRG=00; //00 -najkrtszy czas timera WDT; 07 -najduszy czas WDT
 WDTkick;                        // Start WDT - pierwsze uruchomienie

 SIO_initT1;                     // SIO_initT2; 
 while(1) {
    for (i=0;t[i];i++) putchar(t[i]);       // napis "Jak si masz !"
    puts(" Nacisnij cos...\n ");                                     
    c=_getkey();                                  // czekanie na znak
    putchar(c);              // odebrany znak pojawi si na terminalu
    printf("\n Odebrany znak ASCII: %c (HEX:%02bx DEC:%03bu)",
                                                           c,c,c);   
 }                                        
}

//-------------------------------- nadawanie znaku poprzez zcze SIO
char putchar(char c) {        
    do {                       
       WDTkick;                                     // pobudzanie WDT
    } while (!TI);           // czekanie na gotowo ukadu nadawania 
    TI = 0;                     // zerowanie gotowoci - ukad zajty 
    SBUF = c;                                       // wysanie znaku 
    return c;
}

//----------------------------------- odbir znaku poprzez zcze SIO
char _getkey(void) {                        
  
    do { 
     WDTkick;            // Usu aby si przekonac jak dziaa WDT !!!
    } while (!RI);         // czekanie na gotowo ukadu odbiorczego
    RI = 0;                     // zerowanie gotowoci - ukad zajty
    return (SBUF);                                    // odbir znaku
  }

