/*********************************************************************
Flash_prog.c          (program dopisuje dane do obszaru pamici Flash)

Zapis do pamici kodu programu (Flash) procesora AT89C51xD2.
Od od zadanego adresu (0x1000) w pamici Code zapisuje si
tekst "01234567890abcdef". Wyniki s przekazywane poprzez zcze 
transmisji szeregowej: 9600 8N1 .

*********************************************************************/
#pragma small
#pragma REGPARMS    // przekazywanie parametrw funkcji przez rejestry
#include "51xD2.h"             // zbir definiujcy rejestry procesora
#include"sio_init.h"
#include <stdio.h>

//Prototypy funkcji zapisu do pamici Code   
BYTE code_wr_block(BYTE NoOfBytes,WORD Code_addr,WORD Xdat_addr);

//  Usu komentarze poniej i skompiluj z opcj SRC(flash.a51) .......
//                                - obejrzyj listing w kodzie asembler
//  BYTE code_wr_block(BYTE NoOfBytes,WORD Code_addr,WORD Xdat_addr){
//   return (NoOfBytes+Code_addr+Xdat_addr); //Tylko dla przykadu !!!
//  }

BYTE *ff = 0x51000;    //wskanik do pamici Code do obszaru od 0x1000
void main(void) {
  xdata  BYTE info[]="01234567890abcdef";            //Tekst do zapisu
  BYTE i,j;
  SIO_initT2;                   // Inicjalizacja transmisji szeregowej
  printf("START 01\r");  
  AUXR1|= 0x20;         // odblokowanie dostpu do programu bootloader 

  for(j=0;j<0x10;j++)  {           //Zapisuje si 16 blokw do pamici
    code_wr_block(16,ff+j*16,info);    //zapis do pamieci Flash tekstu
    printf("Pointer: %p  : ", ff+j*16); // drukowanie wskanika blokw
    for(i=0;i<16;i++)  printf("%02bx ",*(ff+i+j*16));     // zawarto 
    printf("\r"); 
  }    
     
  while (1);                                        // koniec programu
}
