/**************************************************************************
EEPROM_prog.c                               (test dziaania pamici EEPROM)

Zapis do pamici EEPROM procesora AT89C51ED2.
Od adresu 0x0000 w pamici EEPROM (Xdata) zapisuje si tekst 
"01234567890abcdef".
Wyniki s wyprowadzane poprzez zcze transmisji szeregowej: 9600 8N1 .
**************************************************************************/
#include "51xD2.h"                 // zbir definiujcy rejestry procesora 
#include"sio_init.h"
#include <stdio.h>

BYTE *EE = 0x20000;                     //wskanik do pamici EEPROM (Xdata) 

//-------------------------------------- podprogram odczytu z pamici EEPROM 
void EEPROM_rd(BYTE NoOfBytes, BYTE  indexEE,  BYTE *to) {
     BYTE i,n;
     while (EECON & 0x01);                    // czekanie na gotowo EEPROM
     for(i=0;i<NoOfBytes;i++){
       EECON =  0x02;                                // wstaw EEPROM do XRAM
       n=EE[indexEE+i];                            // odczytaj bajt z EEPROM
       EECON =  0x00;                                 // usu EEPROM z XDATA
       *(to+i)=n;                               // zapamitaj odczytany bajt
     }   
}

//-------------------------------------  podprogram zapisu do pamici EEPROM 
void EEPROM_wr(BYTE NoOfBytes, BYTE  indexEE,  BYTE *from) {
    BYTE i,n;
    bit x;
    for(i=0;i<NoOfBytes;i++){
       while (EECON & 0x01);                  // czekanie na gotowo EEPROM
       n=*(from+i);                                // pobierz bajt do zapisu
       x=EA;                                     // zapamitaj stan przerwa
       EA=0;                                            // blokuj przerwania
       EECON =  0x02;                                // wstaw EEPROM do XRAM
       EE[indexEE+i]=n;                                       // zapisz bajt
       EECON =  0x00;                                 // usu EEPROM z XDATA
       EA=x;                                       // odzyskaj stan przerwa
     }   
}

//--------------------------------------------------------------------------
void main(void) {
  code  BYTE master[]="01234567890abcdef";                 //tekst do zapisu
  idata  BYTE result[16];                                  //odczytany tekst
  BYTE i,j;
  WORD ff=0;
  SIO_initT1;                         // inicjalizacja transmisji szeregowej
  printf("EE TEST\r");  
  for(j=0;j<10;j++)  { 
    EEPROM_wr(16,ff+j*16,master);   //zapis do pamici EEPROM staego tekstu
    printf("EE index: %x  : ", ff+j*16);      // drukowanie wskanika blokw
 
    EEPROM_rd(16,ff+j*16,result);
    for(i=0;i<16;i++)  printf("%bx ",result[i]);     //drukowanie zawartoci
    printf("\r"); 
  }        
  while (1);                                              // koniec programu
}

