/******************************************************************
SPI_test.c               (test interfejsu SPI w procesorach '51xD2)

Po poczeniu przewodem wyprowadze procesora MISO/P1_5 i 
MOSI/P1_7 mona przeprowadzi test dziaania zcza SPI. Interfejs
SPI jednoczenie transmituje i odbiera bajt. Poczenie przewodem
linii MOSI I MISO spowoduje, e ten sam wysyany bajt bdzie 
jednoczenie odbierany. Gdyby odebrano inny bajt ni nadany lub 
pojawi si bd transmisji program zostanie zakoczony z 
komunikatem o bdzie.
Wyniki programu wyprowadzane s na zcze SIO z parametrami 9600bps
8-N-1. Interfejs SPI posiadaj procesory '51xD2.
******************************************************************/
#include "51xD2.h"
#include "SIO_init.h"
#include <stdio.h>

BYTE SPI_error=0;                      // licznik bdw transmisji

// -----------------------------  procedura nadawania i odbioru SPI
BYTE SPI_TX_byte(BYTE TX_data) {
 
  SPDAT=TX_data;                       // nadawanie bajtu przez SPI
  do {
       if ((SPSTA & 0x70) != 0) SPI_error++; // bd transmisji SPI
  } while (! (SPSTA & 0x80));   // sprawdzenie koca transmisji SPI

  return SPDAT;                                // odebrany bajt SPI
}

// ----------------------------------------------------------------
void main(void) {
  BYTE i,x;

  SIO_initBDRf;                                // przygotowanie SIO
  SPSTA =0x80;                             // gotowo do nadawania
  printf("\n\nSPI test\n");
  SPCON = 0xB2;//        konfiguracja SPI: Master, SPCK=Fosc/128...
  SPCON |= 0x40;                        // SPE=1 : odblokowanie SPI
  printf("\n Writing 0..255\n");
	
  for ( i=0; 1 ; i++ ) {   //  nadawanie i odbir liczb 0x00...0xFF
       if ( (x=SPI_TX_byte(i) ) != i ) break; 
       if (SPI_error > 0)              break;
       printf("%02bx ",x); 
    }
  printf(" SPI error \n");
}

