/**********************************************************************
TEST_LCD8_Xdata.c       (Podcz wywietlacz LCD do przestrzeni Xdata !)

Program demonstruje sposb obsugi wywietlacza LCD.
Wywietlacz podczony jest do przestrzeni Xdata:
  - sygnay  AD0...AD7 (P0_0...P0_7) do 8 lini danych wywietlacza DB
  - sygnay  RD~ i WR~ poprzez bramk 74C00 do linii E (Enable)
  - lini A15(P2_7) do lini RD/WR~
  - lini A14(P2_6) do lini D/C~ (Data/Control~) zwanej take RS 
    (Register Select)

  Rejestr ControlWR znajduje si w przestrzeni Xdata pod adresem 0x3FFF.
  Rejestr DatalWR   znajduje si w przestrzeni Xdata pod adresem 0x3FFF.
***********************************************************************/
#include "51xD2.h"                          // zbir nagwkowy adresw 
#include <absacc.h>              // prototyp XBYTE[] jest w tym zbiorze 

// ----------------------------------  adresy rejestrw wywietlacz LCD 
#define LCD_A_ctrlWR XBYTE[0x3FFF]    // adres rejestru ControlWR w LCD 
//#define  LCD_A_ctrlWR   (*(BYTE *)(0x023FFF))   
                          
#define LCD_A_dataWR XBYTE[0x7FFF]      // adres  rejestru DataWR w LCD 
//#define  LCD_A_dataWR   (*(BYTE *)(0x027FFF))        

#define WAIT  for(var=0; var<0x8000;var++)                // opnienie

//---------------------------------------------------------------------
void main(void) { 
  WORD var,i;
  WAIT;                                                     // poczekaj
  LCD_A_ctrlWR=0x01;           //zapis do ControlWR polecenia RESET LCD
  WAIT;                                                     // poczekaj
  LCD_A_ctrlWR=0x0F;              //zapis do ControlWR polecenia LCD ON

  for(i=0;i<10;i++) {
           WAIT;                                            // poczekaj
           LCD_A_dataWR = '0'+i;        // zapis do DataWR znakw ASCII
  }
  while(1);                                          // koniec programu
}

