/******************************************************************
LCD8_Xdata.c          (sterowanie wywietlacza LCD podaczonego do 
                                             ...przestrzeni Xdata )

Program demonstruje sposb obsugi wywietlacza LCD.
Wywietlacz LCD podaczony jest do przestrzeni Xdata procesora.
******************************************************************/
#include "51xD2.h"          // zbir definiujcy rejestry procesora 

void LCD_ctrlWR ( BYTE cmde);
void LCD_dataWR ( BYTE byte);
void LCD_ini (void);
BYTE check_busy (void);

#define WAIT  for(var=0; var<0x2000;var++)      // (1) !
//#define WAIT  while (check_busy() )           // (2) !

//-----------------------------------------------------------------
void main(void) { 
  WORD i;
  LCD_ini();
             
  for(i=0;i<10;i++) {
       LCD_dataWR('X'+i);
  }
  while(1); 
}

/*=================================================================
  Wywietlacz LCD podczony jest do przestrzeni Xdata:
   - sygnay  AD0...AD7 (P0_0...P0_7) do 8 lini danych wywietlacza 
   - sygnay  RD~ i WR~ poprzez bramk 74C00 do linii E (Enable)
   - linia A15(P2_7) do lini RD/WR~
   - linia A14(P2_6) do lini D/C~ (Data/~Control) zwanej take RS
=================================================================*/

//-------------------------------- Adresy rejestrw wywietlacz LCD                    
#define LCD_A_ctrlRD (*(BYTE *)(0x02bfff)) // adres ControlRD w LCD                        
#define LCD_A_ctrlWR (*(BYTE *)(0x023fff)) // adres ControlWR w LCD                          
#define LCD_A_dataWR (*(BYTE *)(0x027fff))    // adres DataWR w LCD

//------------- zapis sowa sterujcego Control do wywietlacza LCD 
void LCD_ctrlWR ( BYTE cmde) {
    WORD var;
    WAIT;                                               // poczekaj 
    LCD_A_ctrlWR=cmde;         // zapis cmde pod adres LCD_A_ctrlWR
}

//--------------------------- zapis danych Data do wywietlacza LCD 
void LCD_dataWR ( BYTE byte) {
    WORD var;
    WAIT;                                               // poczekaj 
    LCD_A_dataWR=byte;         // zapis byte pod adres LCD_A_dataWR
}

// ------------------- sprawdzenie flagi zajtoci wywietlacza LCD 
BYTE check_busy (void) {
    return (LCD_A_ctrlRD & 0x80); // najstarszy bit to zajto LCD
}

//---------------------------------- inicjalizacja wywietlacza LCD
void LCD_ini (void) {
BYTE init_tab[] = {0x01,0x0F};                 // LCD_RESET, LCD_ON
WORD i,j;
  for(j=0;j<0x1000;j++);      // poczekaj na reset wewntrzny w LCD
  for (i = 0; i < sizeof init_tab; i++) { 
       LCD_ctrlWR(init_tab[i]);        // zapis danych inicjujcych
 }
}


