/*************************************************************************
LCD8bit.c                      (biblioteka LCD dla 8-bitowego interfejsu)

Biblioteka obsugi wywietlacza LCD.
Wywietlacz podczony jest do przestrzeni XDATA:
  sygnay AD0...AD7 (P0_7...P0_0) do 8 linii danych wywietlacza DB7...DB0
  sygnay RD~ i WR~ poprzez bramk 74C00 do linii E (Enable)
  lini A15(P2_7) do lini RD/WR~
  lini A14(P2_6) do lini D/C~ (Data/Control~) zwanej take RS

*************************************************************************/

#include "51xD2.h"                 // zbir definiujcy rejestry procesora 
#include <absacc.h>              // zbir zawierajcy makrodefinicj XBYTE 
#include "lcd.h"   // zbir nagwkowy definicji adresw rejestrw i bitw 

#define INTERFACE LCD_8BIT

// Adresy rejestrw wywietlacz LCD --------------------------------------
                            // adres  rejestru ControlRD wywietlacza  LCD  
#define  LCD_A_ctrlRD   XBYTE[0xbfff] 

                              // adres rejestru ControlWR wywietlacza LCD  
#define  LCD_A_ctrlWR   XBYTE[0x3fff]

                              // adres  rejestru  DataRD wywietlacza  LCD  
#define  LCD_A_dataRD   XBYTE[0xffff] 

                              // adres  rejestru  DataWR wywietlacza  LCD  
#define  LCD_A_dataWR   XBYTE[0x7fff] 

WORD var;
//#define WAIT  for(var=0; var<0x2000;var++)                     // (1) !
#define WAIT  while (LCD_A_ctrlRD & 0x80)                    // (2) !

// funkcje obsugi wywietlacza LCD ------------------------------------ 
//======================================================================

// zapis danych do LCD -------------------------------------------------
void LCD_dataWR(char val) {                  
 WAIT;                                 // sprawdzenie bitu gotowoci LCD 
 LCD_A_dataWR=val;                                        // zapis danej 
}

// zapis sowa sterujcego do LCD--------------------------------------- 
void LCD_ctrlWR(char val) {  
 WAIT;                                 // sprawdzenie bitu gotowoci LCD 
 LCD_A_ctrlWR=val;                            // zapis sowa sterujcego 
}

// odczyt sowa statusowego LCD----------------------------------------- 
char LCD_ctrlRD(void) {             
 WAIT;                                 // sprawdzenie bitu gotowoci LCD 
 return(LCD_A_ctrlRD);                       // odczyt sowa statusowego 
}

// odczyt danych z LCD--------------------------------------------------- 
char LCD_dataRD(void) {                      
 WAIT;                                 // sprawdzenie bitu gotowoci LCD 
 return(LCD_A_dataRD);                                   // odczyt danej 
}


#include "lcd_comm.c"
