//-----------------------------------------------------------------------
// KEYB.c                          (modu obsugi klawiatury skaningowej)
//
// Procedura _getkey przystosowana do  obsugi klawiatury 
// telefonicznej o 12-tu klawiszach. Procedura _getkey uywa moduu 
// scan do sprawdzania stanu klawiatury.
//       _______  
//      | 1 2 3 |
//      | 4 5 6 |
//      | 7 8 9 |
//      | * 0 # |
//       _______
//
//-----------------------------------------------------------------------
#include "51xD2.h"                          // zbir nagwkowy procesora

#define KBD_OUT P1
#define KBD_IN  P1
#define SHIFT   P3_2

#define DELAY for(l=0;l<250;l++)

// obsuga klawiatury ---------------------------------------------------
BYTE scan(void ) {                   // skanowanie jednokrotne klawiatury
  code BYTE toASCII[2][4][3]= //tablica zamiany kodw klawiatury na ASCII
 {
     {        
          {'+'     ,    '-'  ,   '*'     },
          {'/'     ,    '&'  ,   '|'     },
          {'^'     ,    0x1b ,   'e'     },                    //1B - ESC
          {' '     ,    '.'  ,   '\r'    },              //SPACE, '.', CR
     },
     {        
          {'1'     ,    '2'  ,   '3'     },
          {'4'     ,    '5'  ,   '6'     },
          {'7'     ,    '8'  ,   '9'     },
          {'\b'    ,    '0'  ,  '\t'     },                //BS, '0', TAB
     },
 };
 BYTE i,j,l,msk,mskr,kbd;
 msk  = 0x10;
 for(i=0;i<3;i++) {
   DELAY;
   KBD_OUT = (~msk);                       //pobudzenie kolumny klawiatury
   mskr = 0x01;
   for(j=0;j<4;j++) {
      kbd = KBD_IN & mskr;                     //odczyt wiersza klawiatury  
      if(!kbd)  { 
               l=SHIFT;
               return (toASCII[l][j][i]);
      }
      mskr = mskr << 1; 
   }  
   msk = msk << 1;
 }
 return 0xff;                           // nie nacinito adnego klawisza
}

// ----------------------- funkcja zgodna ze standardem biblioteki stdio.h
char _getkey(void) {      // czekanie na nacinicie i zwolnienie klawisza
 BYTE k,k1;
 WORD l;
 while(1) { 
   k = scan();
   if( k != 0xff) {                             //jeli nacinito klawisz
     do {
       DELAY;
       k1 = scan();                    //sprawdzenie czy zwolniono klawisz
     } while( k1 != 0xff);
     return(k);
   }
 }
}
 
