/*****************************************************************
int_keyb.c            (przerwania wyzwalane poziomem lub zboczem)

Program ilustruje sposb uycia przerwania zewntrznego 
wyzwalanego poziomem.
Program gwny generuje na linii P1_3 (Buzzer)  sygna 
dwikowy. Nacinicie przycisku P3.2 (INT0) powoduje przerwanie
a to sprawia, e grupa diod LEDS wywietla kolejne stany
licznika piercieniowego (jedna dioda jest zapalona, pozostae
s zgaszone).

*****************************************************************/
#include "AT89C51xD2.h"    // zbir definiujcy rejestry procesora 
#include "lcd.h"                     
#include "LCD4bit.c"                 
                     
#define  LEDS      P2                           // zesp diod LED 

#define BUZZER  P3_3
#define KBD_OUT P1
#define KBD_IN  P1
#define SHIFT   P3_2

BYTE get_char=0xff;

// obsuga klawiatury ---------------------------------------------------
BYTE scan(void ) {                   // skanowanie jednokrotne klawiatury 
  code BYTE toASCII[2][4][3]= //tablica zamiany kodw klawiatury na ASCII
 {
     {        
          {'A'     ,    'B'  ,   'C'     },
          {'D'     ,    'E'  ,   'F'     },
          {'G'     ,    'H'  ,   'I'     },
          {'\b'    ,    ' '  ,   '\r'    },                //BS, space, CR
     },
     {        
          {'1'     ,    '2'  ,   '3'     },
          {'4'     ,    '5'  ,   '6'     },
          {'7'     ,    '8'  ,   '9'     },
          {'*'     ,    '0'  ,   '#'     },
     },
 };

 BYTE i,j,l,msk,mskr,kbd;
 msk  = 0x10;
 for(i=0;i<3;i++) {
   KBD_OUT = (~msk);                       //pobudzenie kolumny klawiatury
   mskr = 0x01;
   for(j=0;j<4;j++) {
      kbd = KBD_IN & mskr;                     //odczyt wiersza klawiatury  
      if(!kbd)  return ( toASCII[SHIFT][j][i]);
      mskr = mskr << 1; 
   }  
   msk = msk << 1;
 }
 return 0xff;                           // nie nacinito adnego klawisza
}

// ----------------------- funkcja zgodna ze standardem biblioteki stdio.h
char _getkey(void) {
  BYTE x; 
  WORD i;
  while (get_char == 0xff) ;
  x=get_char;
  while((KBD_OUT & 0x0F) != 0x0F);
  get_char=0xFF;
  return x;
}

//----------------------------------------------------------------
void main(void) {
   BYTE x;
   LCD_init;                     
   KBE=0x0F;
   KBD_OUT=0x8f;
   KBLS=0xF0;
   IEN1=0x01;                   // odblokowanie przerwania od KEYB
   EA =1;                      // odblokowanie wszystkich przerwa 
   while(1) {
   putchar(_getkey());
  } 
}

// podprogram obsugi przerwania INT0 ----------------------------
void KEYB_int(void) interrupt 7 using 1 { 
  BYTE x;             
  x=KBF;    
  KBD_OUT =0xFF;
  get_char= scan();
  KBD_OUT=0x8f;                         
}



