/*****************************************************************
player.c                                     (odtwarzanie dwiku)

Program odtwarza mow lub muzyk z wykorzystaniem modulacji PWM.
Program obsugi przerwania od ukadu Timer PCA pobiera 8-bitowe
dane nagranego dwiku z tablicy x[]. 
 
Uwaga:  Do linii P1_7 procesora naley doczy suchawki o duej
        opornoci ok. 1...4kOhm. 
*****************************************************************/

#include "51xD2.h"    // zbir definiujcy rejestry procesora 

code char x[]={
// #include "dzien.dat" 
// #include "signal.dat"  
// #include "ding.dat"  // przygotowany sygna wav (8 bitw, 8kHz)
#include "sound.dat"     // ... w postaci tablicy (np. z MATHLABa)
};

void PWM_init (void);
//----------------------------------------------------------------
void main(void) {
     EC=1;                  // odblokowanie przerwa od ukadu PCA
     EA =1;                       // odblokowanie systemu przerwa
     PWM_init();
     while(1) {}
}

// przygotowanie PWM ---------------------------------------------
void PWM_init (void) {
   P1_7 = 1;                          // przygotowanie wyjcia PWM 
   CMOD = 0x01;                       // PCA clock z ukadu TIMER0  
   CCAPM4 = 0x42;                        // ustaw kana 4 jako PWM 
   CR = 1;                                      // start PCA timer
}

// podprogram przerwania Timer PCA --------------------------------
void PCA_int(void) interrupt 6 using 1 {    
  static WORD i=0;               // indeks kolejnych prbek dwiku 
  CH=0xff;
  i++;
  if (i== sizeof x) i=0;           // odtwarzanie dwiku "w kko"
  CCAP4H =x[i];                      //zapisz prbk dwiku do PWM
  CF=0;                                 // zerowanie przerwania PCA
}
