/********************************************************************
idle.c         (ilustracja obnienia poboru mocy procesora typu IDLE)

Program demonstruje uycie energooszczdnego trybu pracy procesora 
IDLE na przykadzie komputerowego notatnika, umoliwiajcego 
pamitanie np. numerw telefonw (oglnie - dowolnego tekstu).
Program po uruchomieniu wyprowadza na terminal transmisji szeregowej
to co znajduje si pamici IDATA. Pami ta zawiera ostatnio 
wprowadzony tekst z klawiatury terminala.
Od tego momentu uytkownik ma okoo 30 sek. czasu na wprowadzenie 
nowego tekstu. Jeli nie napisze on nowej informacji (tekstu) to 
po tym czasie procesor obniy pobr mocy wykonujc polecenie IDLE. 
Jeli z klawiatury zostanie wprowadzony nowy tekst, to zastpi on 
poprzedni wiadomo. Kocem tekstu jest znak 0x00. 
Wyjcie z trybu IDLE jest moliwe tylko poprzez aktywne przerwanie 
lub RESET. W tym programie przed wejciem w tryb IDLE odblokowuje 
si przerwania od transmisji SIO. Nacinicie dowolnego klawisza na 
terminalu transmisji szeregowej powoduje wyjcie ze stanu IDLE
i powrt do programu.
Program wymaga aby zawarto wewntrznej pamici IDATA nie bya
inicjalizowana: std zmiany w programie STARTUP.a51.
UWAGA: biblioteki stdio.h zawieraj standardowo obsug transmisji 
szeregowej i dlatego nie potrzeba definiowa funkcji 
putchar i _getkey.
*****************************************************************/

#include "51xD2.h"         // zbir definiujcy rejestry procesora 
#include "SIO_init.h"    // zbir makrodefinicji przygotowania SIO
#include <stdio.h> 
#define  LEDS        P1                             // zesp diod  
#define  TIMEOUT     0xfffff   
#define  SIZE        0x50   
 
// #define   MEM    ((BYTE *)0x010030)  
//                 ... umieszczenie tablicy MEM od zadanego adresu 

BYTE MEM[SIZE];
//----------------------------------------------------------------
void main(void) { 
 long int i; 
 unsigned char k,x,NewMessage;
 SIO_initT2;                          // 9600BPS (8-N-1) dla 24MHz 
 puts("\n\rTekst w pamieci:--------------------------------\r\n");  
  EA =1; 
 
 while(1) {                                     // ptla bez koca 
  LEDS=0x00;                         
  puts(MEM);           // wyprowadzenie tekstu z pamici notatnika 
  puts("\n\rWpisz nowy tekst:------------------------------\r\n");
 
  NewMessage=0;
  k=0;
  puts("\n\r");                    // wyprowadzenie znakw CR i LF 
  for(i=0;i<TIMEOUT;i++) {       //  czekanie ok. 30 sek. na  znak 
      if(RI) {           // RI= 1 oznacza, e odebrany zosta znak 
           x=_getkey();                          // pobranie znaku 
           NewMessage=1;
           putchar(x);                               // echo znaku 
           MEM[k]=x;             // wprowadzenie znakw do pamici
           k=(k+1)%SIZE; // zwikszenie wskanika znakw w pamici 
           i=0;             // wprowadzenie nowego znaku powoduje,  
                      // e czas 30sek. odliczany jest od pocztku 
      }
  }


 LEDS=0x0f;         // Cztery bardziej znaczce diody LEDS wiec. 
          //  Taki stan oznacza, e procesor bdzie w stanie IDLE. 

 if(NewMessage) MEM[k]=0x00;                 // znak koca tekstu 
 TI=0;                   //tu ukad transmisji jest gotowy (TI=1)
           //... a wic trzeba zablokowa przerwanie od nadawania
 ES=1;                     // odblokowanie przerwa od ukadu SIO

 PCON =0x01;                     // wprowadzenie procesora w stan 
                            // Stan IDLE usuwa dowolne przerwanie 

 }
}

//---------------------------------  przerwanie od transmisji SIO
void SIO_int (void) interrupt 4  {                          
 SBUF=0;
 RI=0;         // pomi znak z terminala do wyjcia ze stanu IDLE
 TI=1;                     // odblokowanie gotowoci do nadawania
 ES=0;                     // zablokowanie przerwa od ukadu SIO
} 

