/*****************************************************************
power_down.c         (ilustracja obnienia poboru mocy POWER DOWN)

Program demonstruje uycie energooszczdnego trybu pracy 
mikrokontrolera POWER DOWN na przykadzie komputerowego notatnika,
umoliwiajcego pamitanie np. numerw telefonw 
(oglnie - dowolnego tekstu). Program po uruchomieniu wyprowadza 
na terminal transmisji szeregowej to co znajduje si pamici IDATA.
Pami zawiera ostatnio wprowadzony tekst z klawiatury terminala.
Od tego momentu uytkownik ma okoo 30 sek. czasu na wprowadzenie 
nowego tekstu. Jeli nie napisze on nowej informacji (tekstu) to 
po tym czasie komputer obniy pobr mocy wykonujc polecenie
POWER DOWN. Jeli z klawiatury zostanie wprowadzony nowy tekst,
to zastpi on poprzedni wiadomo. Po upywie okoo 30 sek. 
komputer przejdzie w stan POWER DOWN.
Wyjcie z trybu POWER DOWN jest moliwe tylko poprzez RESET.
Program wymaga aby zawarto wewntrznej pamici IDATA nie bya
inicjowana - std zmiany w programie STARTUP.a51.
UWAGA: biblioteki stdio.h zawieraj standardowo obsug 
transmisji szeregowej i dlatego nie potrzeba definiowa 
funkcji putchar i _getkey.
****************************************************************/

#include "51xD2.h"       // zbir definiujcy rejestry procesora 
#include "SIO_init.h"  // zbir makrodefinicji przygotowania SIO
#include <stdio.h> 
#define  LEDS        P1                           // zesp diod
#define  TIMEOUT     0xfffff   
#define  SIZE        0x50   
 
// #define   MEM    ((BYTE *)0x010030)  
//               ... umieszczenie tablicy MEM od zadanego adresu
BYTE MEM[SIZE];

void main(void) { 
  long int i; 
  unsigned char k,x,NewMessage;
  LEDS=0x00; 
  SIO_initT2;                       // 9600BPS (8-N-1) dla 24MHz 
  puts("RESET ===========================================\n\r");    
  puts(MEM);         // wyprowadzenie tekstu z pamici notatnika 
  puts("\n\rWpisz nowy tekst:============================\r\n");
 
  NewMessage=0;
  k=0;
  puts("\n\r");                  // wyprowadzenie znakw CR i LF 
  for(i=0;i<TIMEOUT;i++) {       // czekanie ok. 30 sek. na znak 
      if(RI) {         // RI= 1 oznacza, e odebrany zosta znak 
            x=_getkey();                       // pobranie znaku 
  
            NewMessage=1;   // jeli odebrano znak ustawi flag 
            putchar(x);                            // echo znaku 
            MEM[k]=x;      // wprowad znak do pamici notatnika 
            k=(k+1)%SIZE;        // zwikszenie wskanika znakw 
            i=0;          // wprowadzenie nowego znaku powoduje, 
                   //  e czas 30sek. odliczany jest od pocztku 
      }
  }

if (NewMessage)  MEM[k]=0x00;               // znak koca tekstu


 LEDS=0x0f;        // Cztery bardziej znaczce diody LEDS wiec 
     //  Taki stan oznacza, e procesor jest w stanie POWER DOWN 

 PCON |=0x02;        // wprowadzenie procesora w stan POWER DOWN 
                            // stan POWER DOWN usuwa tylko RESET  

 LEDS=0x55;                 // Co druga dioda LEDS jest wczona.
        // Jeli program osignie to miejsce bdzie to oznaczao,
                              // e tryb POWER DOWN nie dziaa ! 
 while(1);                                    // ptla bez koca 
}

