//-----------------------------------------------------------------------
// KEYB_int.c      (modua obsugi klawiatury skaningowej z przerwaniami)
//
// Program przedstawia budow procedury _getkey przystosowanej do
// obsugi klawiatury telefonicznej o 12-tu klawiszach.
//       _______  
//      | 1 2 3 |
//      | 4 5 6 |
//      | 7 8 9 |
//      | * 0 # |
//       _______
//
//-----------------------------------------------------------------------
#include "89C51xD2.h"    // zbir definiujcy rejestry procesora 

#define KBD_OUT P1
#define KBD_IN  P1
#define SHIFT   P3_2

BYTE get_char=0xff;

// obsuga klawiatury ---------------------------------------------------
BYTE scan(void ) {                   // skanowanie jednokrotne klawiatury 
  code BYTE toASCII[2][4][3]= //tablica zamiany kodw klawiatury na ASCII
 {
     {        
          {'+'     ,    '-'  ,   '*'     },
          {'/'     ,    '&'  ,   '|'     },
          {'^'     ,    0x1b ,   'e'     },                    //1B - ESC
          {' '     ,    '.'  ,   '\r'    },              //SPACE, '.', CR        
     },
     {        
          {'1'     ,    '2'  ,   '3'     },
          {'4'     ,    '5'  ,   '6'     },
          {'7'     ,    '8'  ,   '9'     },
          {'\b'    ,    '0'  ,  '\t'     },                //BS, '0', TAB
     },
 };

 BYTE i,j,l,msk,mskr,kbd;
 msk  = 0x10;
 for(i=0;i<3;i++) {
   KBD_OUT = (~msk);                       //pobudzenie kolumny klawiatury
   mskr = 0x01;
   for(j=0;j<4;j++) {
      kbd = KBD_IN & mskr;                     //odczyt wiersza klawiatury  
      if(!kbd) {
               l=SHIFT;
               return (toASCII[l][j][i]);
      }
      mskr = mskr << 1; 
   }  
   msk = msk << 1;
 }
 return 0xff;                           // nie nacinito adnego klawisza
}

// ----------------------- funkcja zgodna ze standardem biblioteki stdio.h
char _getkey(void) {
  BYTE x; 
  WORD i;
  while (get_char == 0xff) ;
  x=get_char;
  while((KBD_OUT & 0x0F) != 0x0F);
  get_char=0xFF;
  return x;
}

//----------------------------------------------------------------
void keyb_init(void) {                     
   KBE=0x0F;
   KBD_OUT=0x8f;
   KBLS=0xF0;
   IEN1=0x01;                   // odblokowanie przerwania od KEYB 
}
//#define KEYB_init  keyb_init ()        // inicjalizacja wywietlacza - makro

// podprogram obsugi przerwania INT0 ----------------------------
void KEYB_int(void) interrupt 7 using 1 { 
  BYTE x;             
  x=KBF;    
  KBD_OUT =0xFF;
  get_char= scan();
  KBD_OUT=0x8f;                         
}



