// -----------------------------------------------------------------------
// zbir : LCD.h
// Zbir zawiera definicje umoliwiajce uycie znakowego wywietlacza LCD
// Przed yciem wywietlacza LCD naley wywoa makrodefinicj LCD_init
// -----------------------------------------------------------------------

#ifndef _LCD_H_
#define _LCD_H_


#define NB_ROW 02                         // liczba linii wywietlacza LCD
#define NB_COL 16                // liczba znakw w linii wywietlacza LCD

//Polecenia sterujce do LCD ---------------------------------------------
#define ROW0 0x00                       // adres wiersza nr 0 wywietlacza
#define ROW1 0x40                       // adres wiersza nr 1 wywietlacza
#define ROW2 0x00+NB_COL                // adres wiersza nr 2 wywietlacza
#define ROW3 0x40+NB_COL                // adres wiersza nr 3 wywietlacza
#define CG_RAM   0x40   // polecenie zapisu do pamici definicji znakw CG
#define DD_RAM   0x80             // polecenie zapisu do pamici danych DD
#define CLR_LCD  0x01                                 // zeruj wywietlacz 
#define CUR_ON   0x0F                                      // wcz kursor
#define CUR_OFF  0x0C                                     // wycz kursor
#define BL_OFF   0x0E                            // wycz miganie kursora
#define LCD_4BIT 0x28                                // 4-bitowy interfejs
#define LCD_8BIT 0x38                                // 8-bitowy interfejs

void lcd_init (void);              // inicjalizacja wywietlacza - funkcja
void LCD_clear (void);                           // zerowanie wywietlacza
void LCD_cursorOFF (void);                           // wyczenie kursora: 
                                      //... domylnie kursor jest wczony
void LCD_cursorON (void);                             // wczenie kursora

                                 // ustaw pozycj kursora: wiersz, kolumna
void set_cursor (BYTE rownr,  BYTE  colnr);            // numeracja od 0,0
void get_cursor (BYTE *rownr, BYTE *colnr);     //odczytaj pozycj kursora
#define LCD_init  lcd_init ()        // inicjalizacja wywietlacza - makro
#endif // _LCD_H_ 
