/***********************************************************************
calc.c                       (kalkulator heksadecymalny lub dziesitny) 

Program demonstruje dziaanie prostego kalkulatora dziesitnego
lub heksadecymalnego. Kalkulator uywa odwrotnej notacji polskiej 
(ONP) do wprowadzania argumentw i operacji.
Komunikaty kalkulatora wyprowadzane s na wywietlacz LCD lub zcze 
SIO transmisji szeregowej, z uyciem funkcji z biblioteki stdio.h  .
***********************************************************************/
#include "89C51xD2.h"            // zbir definiujcy rejestry procesora 
#include <stdio.h>
//#define  LCD                              // <<<<  zmieni na LCD/SIO   

#include "lcd.h"
#include "sio_init.h"

#define CharNo     NB_COL+1        // NB_COL liczba znakw w wierszu LCD

void getline (char xdata *line, BYTE n);           // prototyp procedury
                                                // pobrania linii tekstu 
xdata char line[CharNo];

//----------------------------------------------------------------------
void main(void) {
  int a,b,result;                                 // 16-bitowy kalk. hex
  float a_f,b_f,result_f;
  char opr;

  #ifdef SIO
  SIO_initT1;                                 //inicjacja transmisji SIO 
  #endif

  #ifdef LCD
  LCD_init;                                 //inicjacja wywietlacza LCD  
  #endif

  printf("Hex:0/FLOAT:1 ?");   // Kalkulator dziesitny/heksadecymalny ? 
  if (getchar() == '0')
  {

           while(1) { // ONP Kalkulator HEX: argument1 argument2 operand 
             
           #ifdef LCD   
           getchar() ; 
           LCD_clear ();          
           #endif
              getline(line, CharNo); // pobranie 1 linii tekstu z edycj                                                             
              sscanf(line,"%x %x %c", &a,&b,&opr);      // zmie: "%i %i

              switch(opr){
                 case '+':
                          result=a+b;
                          break;
                 case '-':
                          result=a-b;
                          break;
                 case '*':
                          result=a*b;
                          break;
                 case '/':
                          result=a/b;
                          break;
                 case '&':
                          result=a & b;
                          break;
                 case '|':
                          result=a | b;
                          break;
                 case '^':
                          result=a ^ b;
                          break;
                default : 
                          result=0;
                          break;
              } 
             #ifdef LCD  
             LCD_clear (); 
             puts(line); 
             set_cursor(1,0);  
             #endif
             printf("\rHEX==%x\r",result);     // (16) bitowy calc hex             
           }   
  }

/*        
 while (1) {        // ONP Kalkulator FLOAT: argument1 argument2 operand  
     #ifdef LCD            
     getchar() ; 
     LCD_clear (); 
     #endif

     getline(line, CharNo);        // pobranie 1 linii tekstu z edycj 
     sscanf(line,"%f %f %c", &a_f,&b_f,&opr);
 
              switch(opr){
                 case '+':
                          result_f=a_f+b_f;
                          break;
                 case '-':
                          result_f=a_f-b_f;
                          break;
                 case '*':
                          result_f=a_f*b_f;
                          break;
                 case '/':
                          result_f=a_f/b_f;
                          break;
                 default : 
                          result_f=0;
                          break;
              } 
             #ifdef LCD  
             LCD_clear (); 
             puts(line); 
             set_cursor(1,0);           
             #endif
             printf("\r==%11.4g\r",result_f);
  }   */
}

//----------------------------------------------------------------------                                                                      
// Pobranie jednej linii tekstu z moliwoci edycji znakw               
//---------------------------------------------------------------------- 
void getline (char xdata *line, BYTE n)  {
  BYTE cnt = 0 , indx;   // indx = liczba nacini tego samego klawisza
  static BYTE toggle=0;      //toggle -zmiana sposobu obsugi klawiatury
  char c,pp,nn;               // pp - poprzedni znak ; nn -nastpny znak

  do  {
    c = _getkey ();                                    // pobranie znaku
    pp=nn;   
    nn=c;
    if(c=='\n') c='\r';

    //################# obsuga klawiatury podobna jak w tel. komrkowym               
    if (c <=0x39 && c>=0x30 && c== pp && toggle) {   //znaki ASCII: 0..9
      if (cnt > 0 )  {   
           cnt--;                        // zmniejszenie licznika znakw 
           line--;             // zmniejszenie wskanika biecego znaku        
           putchar ('\b');              // wyprowadzenie znaku Backspace 
      } 
      if (c==0x31)    { c= indx==0 ? '1':  indx==1 ? ' ':indx==2 ? '+':'-' ; }
      else if (c==0x30)    { c= indx==0 ? '0':  indx==1 ? '.':indx==2 ? 'e':'\r' ; }
      else  { c= indx==0 ? c: 0x40 + ((c & 0x0F) -2)*3+indx;}
      indx= (indx+1) & 0x03;
    }
    else  indx=0; 
   
    if (c == 0x1b ) {                   // zmiana obsugi klawiatury ESC
       toggle = ~toggle;
       #ifdef LCD  
       if (toggle )    LCD_cursorOFF ();  
       if (! toggle )  LCD_cursorON  ();  
       #endif
       continue;
   }
   //############################################# koniec dodanej opcjii 

   if (c == '\t' ) {
        putchar (' ');                  // wyprowadzenie znaku Backspace 
        putchar ('\b');
   }
   else
   if (c == '\b' )  {                         // obsuga znakw Bakspace  
      if (cnt > 0)  {            
        cnt--;                           // zmniejszenie licznika znakw 
        line--;                // zmniejszenie wskanika biecego znaku 
        putchar ('\b');                 // wyprowadzenie znaku Backspace 
        putchar (' ');
        putchar ('\b'); 
     }
   }
   else  {                                   
      putchar (*line = c);   // echo znaku i skadowanie znaku w buforze 
      line++;                    // zwikszenie wskanika znakw w linii 
      cnt++;                              // zwikszenie licznika znakw 
   }
  }  while (cnt < n - 1  &&  c != '\r');    // sprawdzenie limitu znakw 
  *line = 0;                 // znak 0 (NULL) jest ogranicznikiem znakw 
} 
