//-----------------------------------------------------------------------
// KEYB.c                         (modua obsugi klawiatury skaningowej)
//
// Program przedstawia budow procedury _getkey przystosowanej do
// obsugi klawiatury telefonicznej o 12-tu klawiszach.
//       _______  
//      | 1 2 3 |
//      | 4 5 6 |
//      | 7 8 9 |
//      | * 0 # |
//       _______
//
//-----------------------------------------------------------------------
#include "51xD2.h"                          // zbir nagwkowy procesora  

#define KBD_OUT P1
#define KBD_IN  P1
#define SHIFT   P3_2

#define DELAY for(l=0;l<250;l++)

// obsuga klawiatury ---------------------------------------------------
BYTE scan(void ) {                   // skanowanie jednokrotne klawiatury 
  code BYTE toASCII[4][3]= //tablica zamiany kodw klawiatury na ASCII
 {      
          {'1'     ,    '2'  ,   '3'     },
          {'4'     ,    '5'  ,   '6'     },
          {'7'     ,    '8'  ,   '9'     },
          {'*'     ,    '0'  ,   '#'    },                //BS, '0', TAB
 };
 BYTE i,j,l,msk,mskr,kbd;
 msk  = 0x10;
 for(i=0;i<3;i++) {
   DELAY;
   KBD_OUT = (~msk);                       //pobudzenie kolumny klawiatury
   mskr = 0x01;
   for(j=0;j<4;j++) {
      kbd = KBD_IN & mskr;                     //odczyt wiersza klawiatury  
      if(!kbd)  {               
               return (toASCII[j][i]);
      }
      mskr = mskr << 1; 
   }  
   msk = msk << 1;
 }
 return 0xff;                           // nie nacinito adnego klawisza
}

// ----------------------- funkcja zgodna ze standardem biblioteki stdio.h
char _getkey(void) {      // czekanie na nacinicie i zwolnienie klawisza
 BYTE k,k1,l;
 while(1) { 
   k = scan();
   if( k != 0xff) {                             //jeli nacinito klawisz
     do {
       DELAY;
       k1 = scan();                    //sprawdzenie czy zwolniono klawisz
     } while( k1 != 0xff);
     return(k);
   }
 }
} 
