/***********************************************************************
Try_mtime.c                    (testowanie moduu mtime z systemu LINUX)

Program zegara odmierzajcego czas liczony w sekundach. Jest to czas
uniwersalny liczony od 01/01/1970 roku. Dla jego przechowywania 
wystarczaj tylko 4-bajty (WORD32). Czas ten jednoznacznie wyznacza
dzie, miesic, rok oraz godziny, minuty i sekundy, a take dzie 
tygodnia. Program w przedstawionej wersji co sekund zwiksza czas
o jeden cay dzie plus 1 sekunda. Daje to moliwo udowodnienia 
poprawnoci dziaania wszystkich procedur zegara i kalendarza.

Program transmituje znaki przez zcze SIO parametrami:9600 bps (8-N-1). 
Program wymaga modelu LARGE podczas kompilacji.
***********************************************************************/
#include "51xD2.h"  
#include <stdio.h>
#include "SIO_init.h"
#include "mtime.c"
#define  LED        P3_2                     // dioda LED mruga co 1sek.

WORD32 Sec_since1970;   // tu zliczane s sekundy zaczynajc od 1/01/1970
tm  Tim;                          // struktura przechowujca Dat i Czas
BYTE update;

#define Fosc   24000000L                     // czstotliwo oscylatora
#define one_msek  (- Fosc/(12 * 1000)*10 )              // 10 milisekund
#define TL0RELOAD    one_msek     
#define TH0RELOAD  ( one_msek )>>8    

#define SECOND       100             // liczba przerwa na jedn sekund
      
// przygotowanie ukadu Timer0 -----------------------------------------
void Timer0_init(void) {
    TH0  = TH0RELOAD;                                   // przygotowanie
    TL0  = TL0RELOAD;
    TMOD = TMOD | 0x01;                      // tryb 1 dla ukadu Timer0
    TR0  = 1;                                 // start dla ukadu Timer0
    ET0  = 1;                    // zgoda na przerwania od ukadu Timer0
}

// obsuga przerwania co 10 msek.--------------------------------------
void T0_int(void)  interrupt 1 using 1  { 
  static idata WORD count=0; 

  TH0 = TH0RELOAD;                      
  TL0 = TL0RELOAD;

  if (++count == SECOND)  {       // zwiksz licznik odliczajcy sekund
      update=1;
      count = 0;
      LED=!LED;
      // Sec_since1970 ++;                         // zwiksz liczb sek.
                              // zwiksz liczb sek. o cay dzie +1sek.
      Sec_since1970 += 60*60*24L +1;       // ... dla testowania programu
  }
}

//----------------------------------------------------------------------
void main(void) { 
      xdata char s_time[40];
      Timer0_init();        
      SIO_initT2;                                   // przygotowanie SIO
      printf("\nLINUX TIME test:");
     
      Tim.tm_year=04 +100;
      Tim.tm_mon=01-1;                      // miesic liczony jest od 0
      Tim.tm_mday=27;  
      Tim.tm_hour=23;
      Tim.tm_min=59;
      Tim.tm_sec=59;     
      Sec_since1970=DateTimeToSec( &Tim );  
      printf("\n%ld ==\n",Sec_since1970 );       // pocztkowe ustawienie
 
      EA=1;
      while (1){                           // drukowanie wynikw co 1sek.
       if( update==1 ) {  
         update=0;
         SecToDateTime(Sec_since1970,&Tim); // zamiana sek.-> Dat i Czas
         DateTimeToStr(&Tim,s_time);    // zamiana Daty i Czasu na ASCII
         printf("\r %s",s_time);             // drukowanie stringu ASCII
       }         
     }
}

