/// Biblioteka moduw obsugi zegara i kalendarza typu LINUX -----------
// Obsuga czasu mierzonego w sekundach od 1/01/1970   -----------------
#include <stdio.h>
#include "mtime.h"

const WORD Days[12] = {                                // dni w miesicu
  31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31  };

const WORD YDays[12] = {                         // dni od pocztku roku
  0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334 };

const char *SWeekday[7] = {
  "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"
};

// Zamiana czasu w sek. od 1970 do postaci struktury -------------------
void SecToDateTime(WORD32 time, tm *tim) {
    WORD hpery, i, cumdays;

    tim -> tm_sec = time % 60;
    time /= 60;                             // teraz time zawiera minuty
    tim -> tm_min = time % 60;
    time /= 60;                            // teraz time zawiera godziny
    i = time / (1461 * 24L);             // liczba blokw po cztery lata
    tim -> tm_year  = (i << 2);
    tim -> tm_year += 70;
    cumdays = 1461L * i;
    time   %= 1461  * 24L;  // reszta godzin po liczbie blokw co 4 lata

    while (1) {
    	hpery = 365 * 24;
    	if ((tim -> tm_year & 3) == 0) hpery += 24;
	    if (time < hpery) break;
	    cumdays += hpery / 24;
	    tim  -> tm_year++;
	    time -= hpery;
    }                 //teraz time zawiera liczb godzin w biecym roku

    tim -> tm_hour = time % 24;
    time /= 24;                         // teraz time zawiera liczb dni
    tim -> tm_yday = time;
    cumdays += time + 4;
    tim -> tm_wday = cumdays % 7;                      // dzie tygodnia

    if ((tim -> tm_year & 3) == 0) {
    	if (time > 60) time--;
    	else if (time == 60) {
		       tim -> tm_mon  = 1; 
               tim -> tm_mday = 29;
	           return; 
	         }
        }

    for (tim -> tm_mon = 0; Days[tim -> tm_mon] < time; tim -> tm_mon++)
	                                        time -= Days[tim -> tm_mon];
    tim -> tm_mday = (time);
}
 
// zamiana Daty i Czasu na sekundy od 1970 -----------------------------
WORD32 DateTimeToSec( tm *tim )  {
    WORD year, month,day,hour,min,sec,leaps;
    WORD32 days, secs;
    year = tim->tm_year;
    month= tim->tm_mon;
    day  = tim->tm_mday;               // dni w miesicu s liczone od 0
    hour = tim->tm_hour;
    min  = tim->tm_min;
    sec  = tim->tm_sec;
    if (year < 70 || year > 138) return (0);
    min   += sec / 60;
    sec   %= 60;                                    // obliczenie sekund
    hour  += min / 60;
    min   %= 60;                                     // obliczenie minut
    day   += hour / 24;
    hour  %= 24;                                    // obliczenie godzin
    year  += month / 12;    
    month %= 12;                                  // obliczenie miesicy
    while (day >= Days[month])	{
    	if (!(year & 3) && (month ==1))	{
	        if (day > 28) { day -= 29;	month++; }
            else break;
	    }
	    else {   day -= Days[month];  month++;	}
	    year += month / 12; 
	    month %= 12;
    }
    year -= 70;
    leaps = (year + 2) / 4;
    if (!((year+70) & 3) && (month < 2)) --leaps;
    days = year*365L + leaps + YDays[month] + day;
    secs = days*86400L + hour*3600L + min*60L + sec ;
    return (secs);
}

//zamia struktury tim na ASCII string dd/mm/yy hh:mm:ss ----------------
void  DateTimeToStr(tm *tim, char *s) {
      sprintf(s,"%s %02d/%02d/20%02d %02d:%02d:%02d",
        SWeekday[tim-> tm_wday], tim->tm_mday,tim->tm_mon+1,
         (tim->tm_year)-100,tim->tm_hour,tim->tm_min,tim->tm_sec);
}

