/*****************************************************************
noise_F.c   (generacja szumu przez generator liczb pseudolosowych)

Program generuje szum pseudolosowy dwoma metodami. Pierwsza metoda 
to symulacja rejestru o sprzniu liniwym typu "wiele-na-jeden"
(typu Fibonacci). Druga to uycie funkcji rnd() ze standardowej
biblioteki. Szum syszalny jest poprzez Buzzer a take moe by
obserwowany na diodzie LED (po obnieniu czstotliwoci).
*****************************************************************/
#include "51xD2.h"         // zbir definiujcy rejestry procesora 
#include  <stdlib.h>
#define  L_SPEAKER   P3_2                    // Buzzer lub gonik

//----------------------------------------------------------------
void main(void) {
bit a,c,l,p;
WORD wCrc = 0xFFFF;          // pocztkowy stan CRC (seed, preset)
     while(1) {
        //LED= L_SPEAKER= rand() & 0x01;    // funkcja standardowa
        a= wCrc & 0x8000;           // wielomian:  x^15+x^13+x^4+1 
        c= wCrc & 0x2000;    
        l= wCrc & 0x0010;  
        p= wCrc & 0x0001;      
        L_SPEAKER= wCrc & 1;       // kady bit wCrc generuje szum
                                   // symulacja rejestru liniowego      
        if( a ^ c ^ l ^ p )  wCrc = (wCrc>>1) | 0x8000; 
                                              else wCrc = wCrc>>1;
     }
}
                               

