/*****************************************************************
noise_G.c   (generacja szumu przez generator liczb pseudolosowych)

Program generuje szum pseudolosowy dwoma metodami. Pierwsza metoda 
to symulacja rejestru o sprzniu liniwym typu "jeden-na-wiele"
(typu Galois). Druga to uycie funkcji rand() ze standardowej
biblioteki. Szum syszalny jest poprzez Buzzer a take moe
by obserwowany na diodzie LED (po obnieniu czstotliwoci).
*****************************************************************/
#include "51xD2.h"         // zbir definiujcy rejestry procesora 
#include  <stdlib.h>

#define Polynom    0xD008 // XILINX: X^16+X^12+X^3+X^1+1  (0xFFFF)
//#define Polynom  0x8408 // CRC-CCITT: X^16+X^12+X^5+1   (0x7FFF)
//#define Polynom  0xA001 // CRC-16: X^16+X^15+X^2+1      (0x7FFF)

#define  L_SPEAKER   P3_2                    // Buzzer lub gonik

//----------------------------------------------------------------
void main(void) {
WORD wCrc=0xFFFF;            // pocztkowy stan CRC (seed, preset)
     while(1) {
        // L_SPEAKER= rand() & 0x01;        // funkcja standardowa
        L_SPEAKER= wCrc & 1;       // kady bit wCrc generuje szum
	    if (wCrc & 0x0001) wCrc = (wCrc >> 1) ^ Polynom;
		                           else  wCrc = wCrc >> 1 ; 
   }
}
                               

