/**********************************************************************
AT25040.h                     (definicje biblioteki pamici EEPROM SPI)
                                         
Definicje (header file) biblioteki moduw obsugi pamici EEPROM SPI.
**********************************************************************/

#ifndef _AT25040_h_
#define _AT25040_n_

#define AT25040_CS              P1_4 // linia CS wyboru pamici EEPROM
#define AT25040_MAX_PAGE                   //2, 4, 8,16 rozmiar strony

#define AT25040_CMD_WREN        0x06                   // write enable
#define AT25040_CMD_WRDI        0x04                  // write disable
#define AT25040_CMD_RDSR        0x05           // read status register
#define AT25040_CMD_WRSR        0x01          // write status register
#define AT25040_CMD_READ        0x03                           // read
#define AT25040_CMD_WRITE       0x02                          // write

#define AT25040_MSK_RDY         0x01         // bity sowa statusowego
#define AT25040_MSK_WEN         0x02
#define AT25040_MSK_BP0         0x04
#define AT25040_MSK_BP1         0x08         // ...
  
BYTE AT25040_read_status(void );
void AT25040_set_write_enable(void );
void AT25040_clear_write_enable(void );
void AT25040_WR_byte(BYTE adr, BYTE to_write );
BYTE AT25040_RD_byte(BYTE adr);
bit  AT25040_ready(void);
void AT25040_RD_data( BYTE adr, BYTE  *ptr_data, BYTE nb_data);
void AT25040_WR_data( BYTE adr, BYTE  *ptr_data, BYTE nb_data);
#define AT25040_WAIT        while ( AT25040_ready() )    //Wait makro
#define AT25040_WR_ENABLE   AT25040_set_write_enable() 
#endif                                                 // _AT25040_h_ 

