/******************************************************************
spi_lib.h                                (definicje biblioteki SPI)     

Zbir definicji biblioteki SPI. Jest to zbir uniwersalny zarwna 
dla ukadowej jak i programowej obsugi SPI.                                         
******************************************************************/

#ifndef _spi_lib_h_
#define _spi_lib_h_

#define spi_miso               P1_5  //  Master Input Serial Output
#define spi_mosi               P1_7  // Master Output  Serial Input
#define spi_sck                P1_6                    // SPI clock
 
#define SPI_RATIO_2            0x00   // definicje prdkoci SPI...
#define SPI_RATIO_4            0x01   // ...
#define SPI_RATIO_8            0x02
#define SPI_RATIO_16           0x03
#define SPI_RATIO_32           0x80
#define SPI_RATIO_64           0x81
#define SPI_RATIO_128          0x82
#define SPI_RATIO_INVALID      0x83   // ...


#define MSK_SPI_SPEN           0x40 // SPI enable -odblokowanie SPI
#define MSK_CLEAR_CRX          0x7C
#define MSK_SPI_SSDIS          0x20                   // SS disable
#define MSK_SPI_MSTR           0x10                   // SPI master

#define MSK_SPI_CPOL           0x08           // clock polarisation
#define MSK_SPI_CPHA          0x04

#define MSK_SPI_SPR2          0x80                //SPI clock speed
#define MSK_SPI_SPR1          0x02
#define MSK_SPI_SPR0          0x01                //...

#define MSK_SPI_SPIF          0x80            // SPI interrupt flag
#define MSK_SPI_MODF          0x10
#define MSK_SPI_WCOL          0x40            // SPI collision Flag


BYTE SPI_byte   ( BYTE to_transmit);                // R/W SPI byte  
void SPI_data   ( BYTE  *ptr_buf, BYTE nb_data);    // R/W SPI data

#endif                                               // _spi_lib_h_ 

