/********************************************************************
spi_lib_hard.c                                 (ukadowa obsuga SPI)

Biblioteka moduw obsugi SPI metod ukadow w procesorach '51xD2.
Kady z podprogramw jednoczenie zapisuje i odczytuje dane. Modu
SPI_byte - nadaje i odbiera bajt danych
SPI_data - nadaje i odbiera cig bajtw.
********************************************************************/
#include "51xD2.h"
#include "spi_lib.h"         // zbir definicji SPI (hard & soft SPI)

volatile BYTE SPI_error=0;           // licznik bdw transmisji SPI

//-------------------- podprogram nadawania i odbioru bajtu przez SPI
BYTE SPI_byte(BYTE tx_byte) {
  SPDAT=tx_byte;                       // wysanie bajtu do nadawania
  do {
       if ((SPSTA & 0x70) != 0) SPI_error++;    // sprawdzanie bdw
  } while (! (SPSTA & MSK_SPI_SPIF));    // sprawdzanie koca odbioru
  return SPDAT;                           // odczyt odebranych danych
}

//------------- podprogram nadawania i odbioru cigu bajtw przez SPI
void SPI_data( BYTE  *ptr_data, BYTE nb_data) {
  while (nb_data > 0)  {
    SPDAT = *ptr_data;                       // wysanie bajtu do SPI
    do {
        if ((SPSTA & 0x70) != 0) SPI_error++;   // sprawdzanie bdw
    } while (! (SPSTA & MSK_SPI_SPIF)); // czekanie na koniec odbioru
    *ptr_data = SPDAT;                                // odczyt bajtu
    ptr_data++;                           // wskanik na kolejne dane
    nb_data--;                           // liczba bajtw do wysania
  }
}


