/*********************************************************************
spi_lib_soft.c                                (programowa obsuga SPI)
                             
Biblioteka moduw obsugi SPI metod programow w procesorach '51.
Kady z podprogramw jednoczenie zapisuje i odczytuje dane. Modu
SPI_byte - nadaje i odbiera bajt danych
SPI_data - nadaje i odbiera cig bajtw .
*********************************************************************/
#include "51xD2.h"
#include "spi_lib.h"
#include <intrins.h>
#define  SPI_soft             // zbir definicji SPI (hard & soft SPI)
volatile BYTE SPI_error=0;            // licznik bdw transmisji SPI

//--------------------  podprogram nadawania i odbioru bajtu przez SPI
BYTE SPI_byte(BYTE to_transmit)  {
  BYTE i,receive=0;
  for(i=8;i>0;i--)       {            // 8 bitw do wysania i odbioru
    spi_sck=0;                         // sygna sclk zaczyna si od 0
    to_transmit=_crol_(to_transmit,1);               // rotacja w lewo
    spi_mosi=(bit)(to_transmit & 1);              // zapis bitu do SPI
    spi_sck=1;                               // zbocze narastajce sck
    receive=_crol_(receive,1);                       // rotacja w lewo
    receive|=(BYTE)(spi_miso);                    // odczyt bitu z SPI
    spi_sck=0;                                 // zbocze opadajce sck
  };
  return receive;
}


//-------------  podprogram nadawania i odbioru cigu bajtw przez SPI
void SPI_data( BYTE  *ptr_data, BYTE nb_data) {
  BYTE x;
  while (nb_data > 0)  {
    x = SPI_byte(*ptr_data);     // nadawanie i odbir bajtu przez SPI
    *ptr_data = x;
    ptr_data++;    // odebrane dane s umieszczane w tym samym buforze
    nb_data--;                            // liczba bajtw do wysania
  }
}




